# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

from customtest import *
from tablatex import tabvar


class TestTabvar(CustomTest):

    def assert_tableau(self, chaine, code_latex):
        self.assert_(tabvar(chaine) == code_latex)

    def test_tableau_variations(self):
        s = "x;f(x);f'(x):1;2;0>>1;0;0<<2;3;0"
        s = "x;f(x);f'(x):(1;2;0)>>(1;0;0)<<(2;3;0)"
        s = "x;f(x):-oo;+oo>>0;-oo|+oo>>+oo;-oo"
        s = "x;f(x): (-oo;+oo)>>(0;-oo|+oo)>>(+oo;-oo)"




    def test_tableau_signes(self):
        s = "x:-oo;+oo|2x+1:-;-1/2;+|3-x:+;3;-|f(x)"


    def test_tableau_valeurs(self):
        s = "f(x)=exp(x+1): 0.25: -5;-4..0;0,5;1;2..6;7;10..21"
        s = "f(x)=exp(x+1): [0.25]: -5;-4..0;0,5;1;2..6;7;10..21"
        #s = "f(x)=exp(x+1): -5;-4..0;0,5;1;2..6;7;10..21 ->0.25"
        s = "(2x+3)^2:-10..0|1..10"



if __name__ == '__main__':
    unittest.main()
